class LOCATION
inherit ENUM
	redefine
		fill_tagged_out_memory,
		copy,
		is_equal
	end
creation make, copy
feature
	x, y, z : INTEGER

	make(x_init, y_init, z_init : INTEGER) is
	do
		x := x_init
		y := y_init
		z := z_init
	end

	is_equal(other : like Current) : BOOLEAN is
	do
		Result := x = other.x and y = other.y and z = other.z
	end

	copy(other : like Current) is
	do
		x := other.x
		y := other.y
		z := other.z
	end
	
	go(direction : INTEGER) is
	do
		inspect direction
		when north then
			y := y + 1
		when south then
			y := y - 1
		when east then
			x := x + 1
		when west then
			x := x - 1
		end
	end

	fill_tagged_out_memory is
	do
		x.append_in(tagged_out_memory)
		tagged_out_memory.append(", ")
		y.append_in(tagged_out_memory)
		tagged_out_memory.append(", ")
		z.append_in(tagged_out_memory)
	end
end
