class DOOR
inherit
	MONSTER_FLOOR
		redefine make,
			colour_method,
			put_colour,
			player_touch
		end
creation make, make_for_world
feature
	make(sq : SQUARE) is
	do
		Precursor(sq)
		put_chr(10)
	end

	put_colour(colour_init : INTEGER) is
	do
		Precursor(colour_init)
		key_number := colour // 16
	end

	key_number : INTEGER

	player_touch(p : PLAYER) is
	do
		if p.keys.item(key_number) then
			--has the right key?
			p.keys.put(false, key_number)
			die
			p.move_to(square)
		else
		end
	end

	colour_method : INTEGER is 1

	kind : STRING is "door"
	zzt_code : INTEGER is 9
end
