class OBJECT_HEADER
inherit READ_TOOL
	redefine fill_tagged_out_memory
	end
creation make
feature
	make is
	do
	end

	p1, p2, p3 : INTEGER
	xstep, ystep : INTEGER
	cycle : INTEGER
	ut, uc : INTEGER
	ins : INTEGER
	length : INTEGER
	data : STRING
	p4 : STRING

	frozen fill_tagged_out_memory is
	do
		tagged_out_memory.append("p1, p2, p3: "); 
		p1.append_in(tagged_out_memory);
		tagged_out_memory.append(", "); 
		p2.append_in(tagged_out_memory);
		tagged_out_memory.append(", "); 
		p3.append_in(tagged_out_memory);

		tagged_out_memory.append("%Np4: "); 
		tagged_out_memory.append(p4.item(1).to_hexadecimal)
		tagged_out_memory.append(" "); 
		tagged_out_memory.append(p4.item(2).to_hexadecimal)
		tagged_out_memory.append(" "); 
		tagged_out_memory.append(p4.item(3).to_hexadecimal)
		tagged_out_memory.append(" "); 
		tagged_out_memory.append(p4.item(4).to_hexadecimal)

		tagged_out_memory.append("%Nut, uc: "); 
		ut.append_in(tagged_out_memory);
		tagged_out_memory.append(", "); 
		uc.append_in(tagged_out_memory);

		tagged_out_memory.append("%Ncycle: ")
		cycle.append_in(tagged_out_memory)

		tagged_out_memory.append(" xstep, ystep: "); 
		xstep.append_in(tagged_out_memory);
		tagged_out_memory.append(", "); 
		ystep.append_in(tagged_out_memory);

		tagged_out_memory.append(" ins: "); 
		ins.append_in(tagged_out_memory);
		tagged_out_memory.append(" length: "); 
		length.append_in(tagged_out_memory);
	end

	read is
	local
		i : INTEGER
	do
		offset := 2
		read_2
		xstep := last_integer
		read_2
		ystep := last_integer
		read_2
		cycle := last_integer
		read_1
		p1 := last_character.code
		read_1
		p2 := last_character.code
		read_1
		p3 := last_character.code
		--read_until(15)

		!!p4.make(4)
		read_1
		p4.add_last(last_character)
		read_1
		p4.add_last(last_character)
		read_1
		p4.add_last(last_character)
		read_1
		p4.add_last(last_character)

		read_1
		ut := last_character.code
		read_1
		uc := last_character.code
		read_until(21)
		read_2
		ins := last_integer
		read_2
		length := last_integer
		read_until(33)
		if length < 0 then length := 0 end
		!!data.make(length)
		from i := 1
		until i > length
		loop
			read_1
			data.add_last(last_character)
			i := i + 1
		end
	end

	object_number : INTEGER
	put_object_number(i : INTEGER) is
	do
		object_number := i
	end
end
