class SDL
inherit SDL_CONSTANT
creation make
feature
	make is
	do
		ext_sdl_init
	end

	test is
	do
		start_drawing
		draw_pixel(100,100,14)
		draw_pixel(100,105,1)
		draw_pixel(105,105,4)
		finish_drawing
		io.read_character
		start_drawing
		draw_pixel(105,100,3)
		draw_pixel(110,105,15)
		draw_pixel(105,110,2)
		finish_drawing
		io.read_character
		start_drawing
	end

	draw_pixel(x, y : INTEGER; c : INTEGER) is
	external "C" alias "ext_draw_pixel"
	end

	tick_ready : BOOLEAN is
	external "C" alias "ext_tick_ready"
	end

	set_tick_interval(t : INTEGER) is
	external "C" alias "ext_set_tick_interval"
	end

	tick_reset is
	external "C" alias "ext_tick_reset"
	end

	ext_sdl_init is
	external "C"
	end

	start_drawing is
	external "C" alias "ext_start_drawing"
	end

	finish_drawing is
	external "C" alias "ext_finish_drawing"
	end

	last_key : INTEGER is
	external "C" alias "ext_last_key"
	end

	key_ready : BOOLEAN is
	external "C" alias "ext_key_ready"
	end

	get_key : INTEGER is
	external "C" alias "ext_get_key"
	end


	set_tile_size(w, h : INTEGER) is
	external "C" alias "ext_set_tile_size"
	end

	read_png(s : STRING) : POINTER is
	do
		Result := ext_read_png(s.to_external)
	end

	ext_read_png(s : POINTER) : POINTER is
	external "C"
	end

	draw_image(x, y : INTEGER; p : POINTER) is
	external "C" alias "ext_draw_image"
	end
end
